package me.km;

import java.util.List;
import me.km.networking.ItemStackDisplayGui;
import me.km.networking.PlayerDisplayGui;
import me.km.networking.PlayerHeadGui;
import me.km.networking.StatusDisplayGui;
import net.minecraft.item.Item;
import net.minecraft.item.ItemArmor;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.util.text.TextFormatting;
import net.minecraftforge.client.event.RenderGameOverlayEvent;
import net.minecraftforge.event.entity.player.ItemTooltipEvent;
import net.minecraftforge.fml.common.eventhandler.SubscribeEvent;
import net.minecraftforge.fml.common.gameevent.TickEvent;
import net.minecraftforge.fml.common.network.FMLNetworkEvent;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class ClientEvents 
{   
    @SubscribeEvent
    public void onClientTick(TickEvent.ClientTickEvent e)
    {
        if(e.phase == TickEvent.Phase.END)
        {
            StatusDisplayGui.INSTANCE.tick();
        }  
    }
    
    @SubscribeEvent
    public void onRenderGui(RenderGameOverlayEvent.Pre e)
    {
        if(e.getType() == RenderGameOverlayEvent.ElementType.POTION_ICONS)
        {
            e.setCanceled(true);
        }
    }
    
    @SubscribeEvent
    public void onRenderGui(RenderGameOverlayEvent.Post e)
    {
        if(e.getType() == RenderGameOverlayEvent.ElementType.EXPERIENCE)
        {
            PlayerDisplayGui.INSTANCE.paint();
            StatusDisplayGui.INSTANCE.paint();
            PlayerHeadGui.INSTANCE.paint();
            ItemStackDisplayGui.INSTANCE.paint();
        }
    }
    
    @SubscribeEvent
    public void onRenderGui(FMLNetworkEvent.ClientDisconnectionFromServerEvent e)
    {
        PlayerDisplayGui.INSTANCE.clear();
        StatusDisplayGui.INSTANCE.clear();
        PlayerHeadGui.INSTANCE.clear();
        ItemStackDisplayGui.INSTANCE.clear();
        ItemStackDisplayGui.INSTANCE.setActive(false);
    }
    
    @SubscribeEvent
    public void showingTooltip(ItemTooltipEvent e) 
    {
        ItemStack stack = e.getItemStack();
        Item item = stack.getItem();
        if(item instanceof ItemArmor)
        {
            NBTTagCompound com = stack.getTagCompound();
            if(com != null && com.hasKey("magic"))
            {
                int magic = com.getInteger("magic");
                if(magic != 0)
                {
                    List<String> list = e.getToolTip();
                    String s = TextFormatting.BLUE + " +";
                    for(int i = 0; i < list.size(); i++)
                    {
                        if(list.get(i).startsWith(s))
                        {
                            list.add(i, TextFormatting.BLUE + " +" + magic + " Magic Armor");
                            break;
                        }
                    }
                }
            }
        }
    }
}
