package me.km.effects.passive;

import me.km.KajetansMod;
import me.km.api.Location;
import me.km.api.Utils;
import me.km.effects.EffectBlockChanger;
import me.km.effects.EffectUtils;
import me.km.events.CustomEventCaller;
import me.km.events.PlayerMoveData;
import net.minecraft.init.Blocks;
import net.minecraft.init.MobEffects;
import net.minecraft.util.DamageSource;
import net.minecraft.util.math.BlockPos;

public class TrapEffects
{        
    public static void addNailTrap(Location l, int id)
    {
        l = l.copyAdd(-1.5, 0, -1.5);
        for(int x = 0; x < 3; x++)
        {
            for(int z = 0; z < 3; z++)
            {
                CustomEventCaller.registerMoveData(new PlayerMoveData((p, data) -> 
                        {
                            if((int) data != KajetansMod.playerbank.getGuildId(p))
                            {
                                p.attackEntityFrom(DamageSource.GENERIC, 6);
                                EffectUtils.addPotionTo(p, MobEffects.SLOWNESS, 200, 1);
                                return true;
                            }
                            return false;
                        }, l.copyAdd(x, 0, z), l.copyAdd(x + 1, 1, z + 1), 10, -1, id));
            }
        }
    }
    
    public static void addNetTrap(Location oldL, int id)
    {
        Location l = oldL.copyAdd(-0.5, 0, -0.5);
        CustomEventCaller.registerMoveData(new PlayerMoveData((p, data) -> 
                {
                    if((int) data != KajetansMod.playerbank.getGuildId(p))
                    {
                        BlockPos b = l.getBlockPos();
                        EffectBlockChanger changer = new EffectBlockChanger(l.getWorld());
                        for(int x = -3; x <= 3; x++)
                        {
                            for(int y = 0; y <= 3; y++)
                            {
                                for(int z = -3; z <= 3; z++)
                                {
                                    if((Math.abs(x) == 3 ? 1 : 0) + (Math.abs(y) == 3 ? 1 : 0) + (Math.abs(z) == 3 ? 1 : 0) >= 2)
                                    {
                                        continue;
                                    }
                                    if(Utils.randomInt(1, 10) >= 3)
                                    {
                                        changer.addBlock(b.add(x, y, z), Blocks.WEB);
                                    }
                                }
                            }
                        }
                        changer.run(120);
                        return true;
                    }
                    return false;
                }, l, l.copyAdd(1, 1, 1), 10, -1, id));
    }
    
    public static void addVineTrap(Location l, int id, int livingTime)
    {
        l = l.copyAdd(-0.9, 0, -0.9);
        CustomEventCaller.registerMoveData(new PlayerMoveData((p, data) -> 
                {
                    if((int) data != KajetansMod.playerbank.getGuildId(p))
                    {
                        EffectUtils.addPotionTo(p, MobEffects.POISON, 60, 2);
                    }
                    return false;
                }, l, l.copyAdd(2.8, 1, 2.8), 10, livingTime, id));
    }
}
