package me.km.environment;

import me.km.api.GlobalText;
import me.km.api.Module;
import me.km.api.ModuleCommand;
import me.km.networking.ModPacketHandler;
import me.km.permissions.Permissions;
import net.minecraft.command.ICommandSender;
import net.minecraft.entity.player.EntityPlayerMP;

public class CommandSeason extends ModuleCommand
{
    public CommandSeason(Module m) 
    {
        super("season", m);
        super.setDescription("Ändert deine Jahreszeit");
        super.setUsage("/season");
        super.setPermission(Permissions.SEASON);
        super.addAlias("season");
    }

    @Override
    public boolean execute(ICommandSender cs, String[] arg) 
    {
        if(!(cs instanceof EntityPlayerMP))
        {
            this.getModule().send(cs, GlobalText.onlyPlayer());
            return true;
        }
        if(arg.length < 1)
        {
            return false;
        }
        EntityPlayerMP p = (EntityPlayerMP) cs;
        try
        {
            Byte b = Byte.parseByte(arg[0]);
            ModPacketHandler.sendSeasonUpdate(p, b);
        }
        catch(NumberFormatException ex)
        {
            return false;
        }
        return true;
    }
}
