package me.km.items;

import me.km.items.weapons.ItemSword;
import me.km.items.weapons.ItemStick;
import me.km.items.tools.ItemSpade;
import me.km.items.tools.ItemPickaxe;
import me.km.items.tools.ItemHoe;
import me.km.items.tools.ItemHammer;
import me.km.items.tools.ItemAxe;
import me.km.items.weapons.ItemDagger;
import me.km.items.herbs.ItemHerbs;
import me.km.items.noglint.ItemNoGlintPotion;
import me.km.KajetansMod;
import me.km.blocks.EnumMetals;
import me.km.blocks.ModBlocks;
import me.km.items.herbs.ItemAquaHerb;
import me.km.items.herbs.ItemGoldHerb;
import me.km.items.noglint.ItemNoGlintLingeringPotion;
import me.km.items.noglint.ItemNoGlintSplashPotion;
import me.km.items.weapons.ItemBattleAxe;
import me.km.items.weapons.ItemScepter;
import me.km.items.weapons.ItemSling;
import net.minecraft.creativetab.CreativeTabs;
import net.minecraft.init.Items;
import net.minecraft.init.MobEffects;
import net.minecraft.init.SoundEvents;
import net.minecraft.inventory.EntityEquipmentSlot;
import net.minecraft.item.EnumDyeColor;
import net.minecraft.item.Item;
import net.minecraft.item.ItemArmor.ArmorMaterial;
import net.minecraft.item.ItemPotion;
import net.minecraft.item.ItemStack;
import net.minecraft.potion.PotionEffect;
import net.minecraft.potion.PotionHelper;
import net.minecraftforge.common.util.EnumHelper;
import net.minecraftforge.registries.IForgeRegistry;

public class ModItems 
{
    /*
        harvestLevel, maxUses, efficiency, damageVsEntity, enchantability
        WOOD(0, 59, 2.0F, 0.0F, 15),
        STONE(1, 131, 4.0F, 1.0F, 5),
        IRON(2, 250, 6.0F, 2.0F, 14),
        DIAMOND(3, 1561, 8.0F, 3.0F, 10),
        GOLD(0, 32, 12.0F, 0.0F, 22);

        for axes
        ATTACK_DAMAGES {6.0F, 8.0F, 8.0F, 8.0F, 6.0F}
        ATTACK_SPEEDS { -3.2F, -3.2F, -3.1F, -3.0F, -3.0F}
    */
    public static final Item.ToolMaterial TOOL_COPPER = 
            EnumHelper.addToolMaterial("COPPER",   1,  161, 6,    1, 18);
    public static final Item.ToolMaterial TOOL_BRONZE = 
            EnumHelper.addToolMaterial("BRONZE",   2,  208, 7, 1.5f, 15);
    public static final Item.ToolMaterial TOOL_REDSTONE = 
            EnumHelper.addToolMaterial("REDSTONE", 0,   59, 1,    0, 22);
    public static final Item.ToolMaterial TOOL_SILVER = 
            EnumHelper.addToolMaterial("SILVER",   2,  250, 5,    2, 20);
    public static final Item.ToolMaterial TOOL_EMERALD = 
            EnumHelper.addToolMaterial("EMERALD",  0, 1248, 7, 2.5f, 10);
    public static final Item.ToolMaterial TOOL_LAPIS = 
            EnumHelper.addToolMaterial("LAPIS",    0,  131, 4,    1, 15);
    
    /*
        String nameIn, int maxDamageFactorIn, int[] damageReductionAmountArrayIn, 
        int enchantabilityIn, SoundEvent soundEventIn, float toughnessIn
        LEATHER("leather", 5, new int[]{1, 2, 3, 1}, 15, SoundEvents.ITEM_ARMOR_EQUIP_LEATHER, 0.0F),
        CHAIN("chainmail", 15, new int[]{1, 4, 5, 2}, 12, SoundEvents.ITEM_ARMOR_EQUIP_CHAIN, 0.0F),
        IRON("iron", 15, new int[]{2, 5, 6, 2}, 9, SoundEvents.ITEM_ARMOR_EQUIP_IRON, 0.0F),
        GOLD("gold", 7, new int[]{1, 3, 5, 2}, 25, SoundEvents.ITEM_ARMOR_EQUIP_GOLD, 0.0F),
        DIAMOND("diamond", 33, new int[]{3, 6, 8, 3}, 10, SoundEvents.ITEM_ARMOR_EQUIP_DIAMOND, 2.0F);
    */
    public static final ArmorMaterial ARMOR_COPPER = 
            EnumHelper.addArmorMaterial("COPPER", KajetansMod.MODID + ":copper", 9, 
                    new int[]{1, 4, 5, 1}, 20, SoundEvents.ITEM_ARMOR_EQUIP_CHAIN, 0);
    public static final ArmorMaterial ARMOR_BRONZE = 
            EnumHelper.addArmorMaterial("BRONZE", KajetansMod.MODID + ":bronze", 13, 
                    new int[]{2, 5, 6, 2}, 20, SoundEvents.ITEM_ARMOR_EQUIP_CHAIN, 0);
    public static final ArmorMaterial ARMOR_STRAW = 
            EnumHelper.addArmorMaterial("STRAW", KajetansMod.MODID + ":straw", 3, 
                    new int[]{1, 1, 1, 1}, 3, SoundEvents.ITEM_ARMOR_EQUIP_LEATHER, 0);
    public static final ArmorMaterial ARMOR_CYLINDER = 
            EnumHelper.addArmorMaterial("CYLINDER", KajetansMod.MODID + ":CYLINDER", 3, 
                    new int[]{1, 1, 1, 1}, 3, SoundEvents.ITEM_ARMOR_EQUIP_LEATHER, 0);
    public static final ArmorMaterial ARMOR_SUIT = 
            EnumHelper.addArmorMaterial("SUIT", KajetansMod.MODID + ":suit", 3, 
                    new int[]{1, 1, 1, 1}, 3, SoundEvents.ITEM_ARMOR_EQUIP_LEATHER, 0);
    
    // nuggets and ingots
    public static ItemBase copperIngot;
    public static ItemBase copperNugget;
    
    public static ItemBase tinIngot;
    public static ItemBase tinNugget;
    
    public static ItemBase bronzeIngot;
    public static ItemBase bronzeNugget;
    
    public static ItemBase silverIngot;
    public static ItemBase silverNugget;
    
    // tools and swords
    public static ItemSword copperSword;
    public static ItemSpade copperShovel;
    public static ItemPickaxe copperPickaxe;
    public static ItemAxe copperAxe;
    public static ItemHoe copperHoe;
    
    public static ItemSword bronzeSword;
    public static ItemSpade bronzeShovel;
    public static ItemPickaxe bronzePickaxe;
    public static ItemAxe bronzeAxe;
    public static ItemHoe bronzeHoe;
    
    public static ItemSling sling;
    
    // armor
    public static ItemArmor copperHelmet;
    public static ItemArmor copperChestplate;
    public static ItemArmor copperLeggings;
    public static ItemArmor copperBoots;
    
    public static ItemArmor bronzeHelmet;
    public static ItemArmor bronzeChestplate;
    public static ItemArmor bronzeLeggings;
    public static ItemArmor bronzeBoots;
    
    public static ItemArmor cylinder;
    public static ItemArmor suitChestplate;
    public static ItemArmor suitLeggings;
    public static ItemArmor suitBoots;
    
    public static ItemArmor strawHat;
    
    // sticks
    public static ItemStick woodenStick;
    public static ItemStick stoneStick;
    public static ItemStick copperStick;
    public static ItemStick bronzeStick;
    public static ItemStick ironStick;
    public static ItemStick goldStick;
    public static ItemStick diamondStick;
    
    // scepters
    public static ItemScepter woodenScepter;
    public static ItemScepter stoneScepter;
    public static ItemScepter copperScepter;
    public static ItemScepter bronzeScepter;
    public static ItemScepter ironScepter;
    public static ItemScepter goldScepter;
    public static ItemScepter diamondScepter;
    
    // dagger
    public static ItemDagger woodenDagger;
    public static ItemDagger stoneDagger;
    public static ItemDagger copperDagger;
    public static ItemDagger bronzeDagger;
    public static ItemDagger ironDagger;
    public static ItemDagger goldDagger;
    public static ItemDagger diamondDagger;
    
    // hammer
    public static ItemHammer woodenHammer;
    public static ItemHammer stoneHammer;
    public static ItemHammer copperHammer;
    public static ItemHammer bronzeHammer;
    public static ItemHammer ironHammer;
    public static ItemHammer goldHammer;
    public static ItemHammer diamondHammer;   
    
    // battle axe
    public static ItemBattleAxe woodenBattleAxe;
    public static ItemBattleAxe stoneBattleAxe;
    public static ItemBattleAxe copperBattleAxe;
    public static ItemBattleAxe bronzeBattleAxe;
    public static ItemBattleAxe ironBattleAxe;
    public static ItemBattleAxe goldBattleAxe;
    public static ItemBattleAxe diamondBattleAxe;
    
    // key
    public static ItemKey silverKey;
    public static ItemKey copperKey;
    public static ItemKey bronzeKey;
    public static ItemKey ironKey;
    public static ItemKey goldKey;
    
    // coins
    public static ItemBase copperCoin;
    public static ItemBase silverCoin;
    public static ItemBase goldCoin;
    
    // misc
    public static ItemScroll magicScroll;
    public static ItemBed realHayBed; 
    public static ItemBase hayBundle; 
    public static ItemBase batWing; 
    public static ItemBase wolfFur; 
    public static ItemBase bearBrownFur; 
    public static ItemBase bearBlackFur; 
    public static ItemBase bearPolarFur; 
    public static ItemBlockSpecial campFire; 
    public static ItemBase cloth;
    public static ItemBase coarseCloth;
    public static ItemGemStone gemStone;
    public static ItemGemStone rawGemStone;
    public static ItemGemStone flawlessGemStone;
    public static ItemBase scroll;
    public static ItemBase soulStone;
    public static ItemBase piercingStone;
    
    // food
    public static ItemColoredSoup coloredSoup;
    public static ItemFood apricot;
    public static ItemFood friedEgg;
    public static ItemBase mushroomStickRaw;
    public static ItemFood mushroomStickCooked;
    public static ItemFood pear;
    public static ItemFood plum;
    
    // icons
    public static ItemBase arrowDown;
    public static ItemBase arrowLeft;
    public static ItemBase arrowRight;
    public static ItemBase arrowUp;
    public static ItemBase checkGreen;
    public static ItemBase checkRed;
    public static ItemBase crossGreen;
    public static ItemBase crossRed;
    public static ItemBase minusGreen;
    public static ItemBase minusRed;
    public static ItemBase plusGreen;
    public static ItemBase plusRed;
    public static ItemBase returnGreen;
    public static ItemBase returnRed;
    public static ItemBase gear;
    
    // herbs
    public static ItemHerbs herbStrong;
    public static ItemHerbs herbShadow;
    public static ItemHerbs herbXp;
    public static ItemHerbs herbSea;
    public static ItemHerbs herbGold;
    public static ItemHerbs herbBreathing;
    public static ItemHerbs herbFire;
    
    public static void init(IForgeRegistry<Item> r) 
    {
        // nuggets and ingots
	copperIngot = register(r, new ItemBase("copper_ingot", "ingotCopper").setCreativeTab(CreativeTabs.MATERIALS));
        copperNugget = register(r, new ItemBase("copper_nugget", "copperNugget").setCreativeTab(CreativeTabs.MATERIALS));
        
        tinIngot = register(r, new ItemBase("tin_ingot", "ingotTin").setCreativeTab(CreativeTabs.MATERIALS));
        tinNugget = register(r, new ItemBase("tin_nugget", "tinNugget").setCreativeTab(CreativeTabs.MATERIALS));
        
        bronzeIngot = register(r, new ItemBase("bronze_ingot", "ingotBronze").setCreativeTab(CreativeTabs.MATERIALS));
        bronzeNugget = register(r, new ItemBase("bronze_nugget", "bronzeNugget").setCreativeTab(CreativeTabs.MATERIALS));
        
        silverIngot = register(r, new ItemBase("silver_ingot", "ingotSilver").setCreativeTab(CreativeTabs.MATERIALS));
        silverNugget = register(r, new ItemBase("silver_nugget", "silverNugget").setCreativeTab(CreativeTabs.MATERIALS));
        
        // repair items
        TOOL_COPPER.setRepairItem(new ItemStack(copperIngot));
        ARMOR_COPPER.setRepairItem(new ItemStack(copperIngot));
        TOOL_BRONZE.setRepairItem(new ItemStack(bronzeIngot));
        ARMOR_BRONZE.setRepairItem(new ItemStack(bronzeIngot));
        TOOL_EMERALD.setRepairItem(new ItemStack(Items.EMERALD));
        TOOL_REDSTONE.setRepairItem(new ItemStack(Items.REDSTONE));
        TOOL_LAPIS.setRepairItem(new ItemStack(Items.DYE, 1, EnumDyeColor.BLUE.getDyeDamage()));
        TOOL_SILVER.setRepairItem(new ItemStack(silverIngot));
        
        // tools and swords
        copperSword =  register(r, new ItemSword(TOOL_COPPER, "copper_sword", "swordCopper"));
        copperShovel = register(r, new ItemSpade(TOOL_COPPER, "copper_shovel", "shovelCopper"));
        copperPickaxe = register(r, new ItemPickaxe(TOOL_COPPER, "copper_pickaxe", "pickaxeCopper"));
        copperAxe = register(r, new ItemAxe(TOOL_COPPER, 7, -3.1f, "copper_axe", "hatchetCopper"));
        copperHoe = register(r, new ItemHoe(TOOL_COPPER, "copper_hoe", "hoeCopper"));
        
        bronzeSword =  register(r, new ItemSword(TOOL_BRONZE, "bronze_sword", "swordBronze"));
        bronzeShovel = register(r, new ItemSpade(TOOL_BRONZE, "bronze_shovel", "shovelBronze"));
        bronzePickaxe = register(r, new ItemPickaxe(TOOL_BRONZE, "bronze_pickaxe", "pickaxeBronze"));
        bronzeAxe = register(r, new ItemAxe(TOOL_BRONZE, 8, -3.0f, "bronze_axe", "hatchetBronze"));
        bronzeHoe = register(r, new ItemHoe(TOOL_BRONZE, "bronze_hoe", "hoeBronze"));
        
        sling = register(r, new ItemSling("sling", "sling"));
               
        // armor
        copperHelmet = register(r, new ItemArmor(ARMOR_COPPER, EntityEquipmentSlot.HEAD, "copper_helmet", "helmetCopper"));
        copperChestplate = register(r, new ItemArmor(ARMOR_COPPER, EntityEquipmentSlot.CHEST, "copper_chestplate", "chestplateCopper"));
        copperLeggings = register(r, new ItemArmor(ARMOR_COPPER, EntityEquipmentSlot.LEGS, "copper_leggings", "leggingsCopper"));
        copperBoots = register(r, new ItemArmor(ARMOR_COPPER, EntityEquipmentSlot.FEET, "copper_boots", "bootsCopper"));
        
        bronzeHelmet = register(r, new ItemArmor(ARMOR_BRONZE, EntityEquipmentSlot.HEAD, "bronze_helmet", "helmetBronze"));
        bronzeChestplate = register(r, new ItemArmor(ARMOR_BRONZE, EntityEquipmentSlot.CHEST, "bronze_chestplate", "chestplateBronze"));
        bronzeLeggings = register(r, new ItemArmor(ARMOR_BRONZE, EntityEquipmentSlot.LEGS, "bronze_leggings", "leggingsBronze"));
        bronzeBoots = register(r, new ItemArmor(ARMOR_BRONZE, EntityEquipmentSlot.FEET, "bronze_boots", "bootsBronze"));
        
        cylinder = register(r, new ItemCylinder(ARMOR_CYLINDER, "cylinder", "cylinder"));
        suitChestplate = register(r, new ItemArmor(ARMOR_SUIT, EntityEquipmentSlot.CHEST, "suit_chestplate", "chestplateSuit"));
        suitLeggings = register(r, new ItemArmor(ARMOR_SUIT, EntityEquipmentSlot.LEGS, "suit_leggings", "leggingsSuit"));
        suitBoots = register(r, new ItemArmor(ARMOR_SUIT, EntityEquipmentSlot.FEET, "suit_boots", "bootsSuit"));
        
        strawHat = register(r, new ItemHat(ARMOR_STRAW, "straw_hat", "hatStraw"));        
        
        // sticks
        woodenStick = register(r, new ItemStick("wood_stick", "stickWood", Item.ToolMaterial.WOOD));
        stoneStick = register(r, new ItemStick("stone_stick", "stickStone", Item.ToolMaterial.STONE));
        copperStick = register(r, new ItemStick("copper_stick", "stickCopper", TOOL_COPPER));
        bronzeStick = register(r, new ItemStick("bronze_stick", "stickBronze", TOOL_BRONZE));
        ironStick = register(r, new ItemStick("iron_stick", "stickIron", Item.ToolMaterial.IRON));
        goldStick = register(r, new ItemStick("gold_stick", "stickGold", Item.ToolMaterial.GOLD));
        diamondStick = register(r, new ItemStick("diamond_stick", "stickDiamond", Item.ToolMaterial.DIAMOND));
        
        // scepter
        woodenScepter = register(r, new ItemScepter("wood_scepter", "scepterWood", Item.ToolMaterial.WOOD));
        stoneScepter = register(r, new ItemScepter("stone_scepter", "scepterStone", Item.ToolMaterial.STONE));
        copperScepter = register(r, new ItemScepter("copper_scepter", "scepterCopper", TOOL_COPPER));
        bronzeScepter = register(r, new ItemScepter("bronze_scepter", "scepterBronze", TOOL_BRONZE));
        ironScepter = register(r, new ItemScepter("iron_scepter", "scepterIron", Item.ToolMaterial.IRON));
        goldScepter = register(r, new ItemScepter("gold_scepter", "scepterGold", Item.ToolMaterial.GOLD));
        diamondScepter = register(r, new ItemScepter("diamond_scepter", "scepterDiamond", Item.ToolMaterial.DIAMOND));
        
        // dagger
        woodenDagger = register(r, new ItemDagger("wood_dagger", "daggerWood", Item.ToolMaterial.WOOD));
        stoneDagger = register(r, new ItemDagger("stone_dagger", "daggerStone", Item.ToolMaterial.STONE));
        copperDagger = register(r, new ItemDagger("copper_dagger", "daggerCopper", TOOL_COPPER));
        bronzeDagger = register(r, new ItemDagger("bronze_dagger", "daggerBronze", TOOL_BRONZE));
        ironDagger = register(r, new ItemDagger("iron_dagger", "daggerIron", Item.ToolMaterial.IRON));
        goldDagger = register(r, new ItemDagger("gold_dagger", "daggerGold", Item.ToolMaterial.GOLD));
        diamondDagger = register(r, new ItemDagger("diamond_dagger", "daggerDiamond", Item.ToolMaterial.DIAMOND));
        
        // hammer
        woodenHammer = register(r, new ItemHammer("wood_hammer", "hammerWood", Item.ToolMaterial.WOOD));
        stoneHammer = register(r, new ItemHammer("stone_hammer", "hammerStone", Item.ToolMaterial.STONE));
        copperHammer = register(r, new ItemHammer("copper_hammer", "hammerCopper", TOOL_COPPER));
        bronzeHammer = register(r, new ItemHammer("bronze_hammer", "hammerBronze", TOOL_BRONZE));
        ironHammer = register(r, new ItemHammer("iron_hammer", "hammerIron", Item.ToolMaterial.IRON));
        goldHammer = register(r, new ItemHammer("gold_hammer", "hammerGold", Item.ToolMaterial.GOLD));
        diamondHammer = register(r, new ItemHammer("diamond_hammer", "hammerDiamond", Item.ToolMaterial.DIAMOND));
        
        // battle axe
        woodenBattleAxe = register(r, new ItemBattleAxe("wood_battleaxe", "battleAxeWood", Item.ToolMaterial.WOOD));
        stoneBattleAxe = register(r, new ItemBattleAxe("stone_battleaxe", "battleAxeStone", Item.ToolMaterial.STONE));
        copperBattleAxe = register(r, new ItemBattleAxe("copper_battleaxe", "battleAxeCopper", TOOL_COPPER));
        bronzeBattleAxe = register(r, new ItemBattleAxe("bronze_battleaxe", "battleAxeBronze", TOOL_BRONZE));
        ironBattleAxe = register(r, new ItemBattleAxe("iron_battleaxe", "battleAxeIron", Item.ToolMaterial.IRON));
        goldBattleAxe = register(r, new ItemBattleAxe("gold_battleaxe", "battleAxeGold", Item.ToolMaterial.GOLD));
        diamondBattleAxe = register(r, new ItemBattleAxe("diamond_battleaxe", "battleAxeDiamond", Item.ToolMaterial.DIAMOND));
              
        // key
        silverKey = register(r, new ItemKey("silver_key", "keySilver", TOOL_SILVER));
        copperKey = register(r, new ItemKey("copper_key", "keyCopper", TOOL_COPPER));
        bronzeKey = register(r, new ItemKey("bronze_key", "keyBronze", TOOL_BRONZE));
        ironKey = register(r, new ItemKey("iron_key", "keyIron", Item.ToolMaterial.IRON));
        goldKey = register(r, new ItemKey("gold_key", "keyGold", Item.ToolMaterial.GOLD));
        
        // coins
        copperCoin = register(r, new ItemBase("coin_copper", "coinCopper").setCreativeTab(CreativeTabs.MISC));
        silverCoin = register(r, new ItemBase("coin_silver", "coinSilver").setCreativeTab(CreativeTabs.MISC));
        goldCoin = register(r, new ItemBase("coin_gold", "coinGold").setCreativeTab(CreativeTabs.MISC));
        
        // misc
        magicScroll = register(r, (ItemScroll) new ItemScroll("magic_scroll", "magicScroll").setCreativeTab(CreativeTabs.MISC));
        realHayBed = register(r, new ItemBed("real_hay_bed", "realHayBed"));
        hayBundle = register(r, new ItemBase("hay_bundle", "bundleHay").setCreativeTab(CreativeTabs.MATERIALS));
        batWing = register(r, new ItemBase("bat_wing", "batWing").setCreativeTab(CreativeTabs.MATERIALS));
        wolfFur = register(r, new ItemBase("wolf_fur", "wolfFur").setCreativeTab(CreativeTabs.MATERIALS));
        bearBrownFur = register(r, new ItemBase("bear_brown_fur", "bearBrownFur").setCreativeTab(CreativeTabs.MATERIALS));
        bearBlackFur = register(r, new ItemBase("bear_black_fur", "bearBlackFur").setCreativeTab(CreativeTabs.MATERIALS));
        bearPolarFur = register(r, new ItemBase("bear_polar_fur", "bearPolarFur").setCreativeTab(CreativeTabs.MATERIALS));
        cloth = register(r, new ItemBase("cloth", "cloth").setCreativeTab(CreativeTabs.MATERIALS));
        coarseCloth = register(r, new ItemBase("coarse_cloth", "coarseCloth").setCreativeTab(CreativeTabs.MATERIALS));
        gemStone = register(r, new ItemGemStone("gem_stone", "gemStone"));
        rawGemStone = register(r, new ItemGemStone("raw_gem_stone", "rawGemStone"));
        flawlessGemStone = register(r, new ItemGemStone("flawless_gem_stone", "flawlessGemStone"));
        scroll = register(r, new ItemBase("scroll", "scroll").setCreativeTab(CreativeTabs.MISC));
        soulStone = register(r, new ItemBase("soul_stone", "soulStone").setCreativeTab(CreativeTabs.MATERIALS));
        piercingStone = register(r, new ItemBase("piercing_stone", "piercingStone").setCreativeTab(CreativeTabs.MATERIALS));
        
        // food
        coloredSoup = register(r, new ItemColoredSoup("colored_soup", "soupColored"));
        friedEgg = register(r, new ItemFood("fried_egg", "friedEgg", 2, 0.3f, false));
        mushroomStickRaw = register(r, new ItemBase("mushroom_stick_raw", "mushroomStickRaw").setCreativeTab(CreativeTabs.FOOD));
        mushroomStickCooked = register(r, new ItemFood("mushroom_stick_cooked", "mushroomStickCooked", 9, 0.9f, false));
        apricot = register(r, new ItemFood("apricot", "apricot", 4, 0.3f, false));
        pear = register(r, new ItemFood("pear", "pear", 4, 0.3f, false));
        plum = register(r, new ItemFood("plum", "plum", 4, 0.3f, false));
        
        // icons
        arrowDown = register(r, new ItemBase("arrow_down", "arrowDown").setCreativeTab(CreativeTabs.MISC));
        arrowLeft = register(r, new ItemBase("arrow_left", "arrowLeft").setCreativeTab(CreativeTabs.MISC));
        arrowRight = register(r, new ItemBase("arrow_right", "arrowRight").setCreativeTab(CreativeTabs.MISC));
        arrowUp = register(r, new ItemBase("arrow_up", "arrowUp").setCreativeTab(CreativeTabs.MISC));
        checkGreen = register(r, new ItemBase("check_green", "checkGreen")).setCreativeTab(CreativeTabs.MISC);
        checkRed = register(r, new ItemBase("check_red", "checkRed").setCreativeTab(CreativeTabs.MISC));
        crossGreen = register(r, new ItemBase("cross_green", "crossGreen").setCreativeTab(CreativeTabs.MISC));
        crossRed = register(r, new ItemBase("cross_red", "crossRed").setCreativeTab(CreativeTabs.MISC));
        minusGreen = register(r, new ItemBase("minus_green", "minusGreen").setCreativeTab(CreativeTabs.MISC));
        minusRed = register(r, new ItemBase("minus_red", "minusRed").setCreativeTab(CreativeTabs.MISC));
        plusGreen = register(r, new ItemBase("plus_green", "plusGreen").setCreativeTab(CreativeTabs.MISC));
        plusRed = register(r, new ItemBase("plus_red", "plusRed").setCreativeTab(CreativeTabs.MISC));
        returnGreen = register(r, new ItemBase("return_green", "returnGreen").setCreativeTab(CreativeTabs.MISC));
        returnRed = register(r, new ItemBase("return_red", "returnRed").setCreativeTab(CreativeTabs.MISC));
        gear = register(r, new ItemBase("gear", "gear").setCreativeTab(CreativeTabs.MISC));
        
        // herbs
        herbStrong = register(r, new ItemHerbs("herb_strong", "herbStrong", new PotionEffect(MobEffects.SPEED, 6000, 1)));
        herbShadow = register(r, new ItemHerbs("herb_shadow", "herbShadow", new PotionEffect(MobEffects.NIGHT_VISION, 3600, 0)));
        herbXp = register(r, new ItemHerbs("herb_xp", "herbXp"));
        herbSea = register(r, new ItemAquaHerb("herb_sea", "herbSea"));
        herbGold = register(r, new ItemGoldHerb("herb_gold", "herbGold"));
        herbBreathing = register(r, new ItemHerbs("herb_breathing", "herbBreathing", new PotionEffect(MobEffects.WATER_BREATHING, 2400, 0)));
        herbFire = register(r, new ItemHerbs("herb_fire", "herbFire", new PotionEffect(MobEffects.FIRE_RESISTANCE, 2400, 0)));
        
        // block special
        campFire = register(r, new ItemBlockSpecial("camp_fire", "camp_fire_item", "campFire", ModBlocks.campFire).setCreativeTab(CreativeTabs.DECORATIONS));
        
        try
        {
            for(int i = 0; i < 3; i++)
            {
                System.out.println("DOING EVIL SHIT");
            }
            ItemPotion potion = new ItemNoGlintPotion();
            register(r, Items.POTIONITEM, potion);
             
            ItemPotion splashPotion = new ItemNoGlintSplashPotion();
            register(r, Items.SPLASH_POTION, splashPotion);
            
            ItemPotion lingeringPotion = new ItemNoGlintLingeringPotion();
            register(r, Items.LINGERING_POTION, lingeringPotion);
            
            PotionHelper.addContainer(potion);
            PotionHelper.addContainer(splashPotion);
            PotionHelper.addContainer(lingeringPotion);
            
            PotionHelper.addContainerRecipe(potion, Items.GUNPOWDER, Items.SPLASH_POTION);
            PotionHelper.addContainerRecipe(splashPotion, Items.DRAGON_BREATH, Items.LINGERING_POTION);
            
            for(int i = 0; i < 3; i++)
            {
                System.out.println("DONE WITH EVIL SHIT");
            }
        }
        catch(Exception ex)
        {
            ex.printStackTrace();
        }
        
        // workaround
        EnumMetals.fixMetalIngots();
    }
	
    private static <T extends Item> T register(IForgeRegistry<Item> r, T item) 
    {
        r.register(item);
        if(item instanceof ItemModelProvider) 
        {
            ((ItemModelProvider) item).registerItemModel(item);
        }
        return item;
    }
    
    private static void register(IForgeRegistry<Item> r, Item old, Item newItem) 
    {
        newItem.setRegistryName(old.getRegistryName());
        r.register(newItem);
    }
}
