package me.km.networking;

import java.lang.reflect.Field;
import java.util.Map;
import me.km.KajetansMod;
import me.km.utils.ReflectionUtils;
import net.minecraft.client.Minecraft;
import net.minecraft.client.gui.FontRenderer;
import net.minecraft.client.gui.Gui;
import net.minecraft.client.gui.GuiBossOverlay;
import net.minecraft.client.gui.ScaledResolution;
import net.minecraft.client.renderer.GlStateManager;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.relauncher.Side;
import net.minecraftforge.fml.relauncher.SideOnly;

@SideOnly(Side.CLIENT)
public class ItemStackDisplayGui extends Gui
{
    private static final ResourceLocation CUSTOM_ICONS = new ResourceLocation(KajetansMod.MODID, "textures/gui/itemstacks.png");
    
    public final static ItemStackDisplayGui INSTANCE = new ItemStackDisplayGui(Minecraft.getMinecraft());
    
    private final Minecraft mc;
    private final int[] icons;
    private boolean inactive = true;
    
    public ItemStackDisplayGui(Minecraft mc)
    {
        this.mc = mc;
        this.icons = new int[27];
        clear();
    }  
    
    public void setActive(boolean active)
    {
        this.inactive = !active;
    }
    
    public void setIcon(int index, int i, int count)
    {
        if(index >= 0 && index < 9)
        {
            index *= 3;
            icons[index] = i < 8 ? 192 + ((i % 4) << 4) : (((i - 8) & 0xF) << 4);
            icons[index + 1] = i < 8 ? (i / 4) << 4 : 32 + (((i - 8) >> 4) << 4);
            icons[index + 2] = count;
        }
    }
    
    public final void clear()
    {
        for(int i = 0; i < 27; i += 3)
        {
            icons[i] = -1;
            icons[i + 1] = 0;
            icons[i + 2] = 0;
        }
    }
    
    private final static Field MAP_BOSS_INFO = ReflectionUtils.getField(GuiBossOverlay.class, "field_184060_g", "mapBossInfos");
    
    //private final static long[] times = new long[1000];
    //private static int index2 = 0;
    //private static long sum = 0;
    
    public void paint()
    {
        /*long l = System.nanoTime();
        
        for(int i = 0; i < 40; i++)
        {
            mc.fontRenderer.drawStringWithShadow(
                    "§üDas §0i§1s§2t §3e§4i§5n §6F§7a§8r§9b§ae§bn§ct§de§es§ft. Das §0i§1s§2t §3e§4i§5n §6F§7a§8r§9b§ae§bn§ct§de§es§ft.", 
                    0, i * 9, 234);
        }
        
        l = System.nanoTime() - l;
        sum -= times[index2];
        sum += l;
        times[index2] = l;
        index2 = (index2 + 1) % times.length;
        System.out.println(sum / times.length);
        */
        if(inactive)
        {
            return;
        }
        
        GlStateManager.enableBlend();
        
        mc.getTextureManager().bindTexture(CUSTOM_ICONS);
        
        ScaledResolution scaledresolution = new ScaledResolution(mc);
        int screenWidth = (scaledresolution.getScaledWidth() >> 1) - 91;
        int y = 3;
        
        try
        {
            Map info = (Map) MAP_BOSS_INFO.get(mc.ingameGUI.getBossOverlay());
            if(!info.isEmpty())
            {
                y += 20;
            }
        }
        catch(IllegalAccessException | IllegalArgumentException ex)
        {
        }
        
        drawTexturedModalRect(screenWidth, y - 3, 0, 0, 182, 22);
        
        int i = 0;
        for(int x = 3; x < 164; x += 20)
        {
            if(icons[i] != -1)
            {
                drawTexturedModalRect(screenWidth + x, y, icons[i], icons[i + 1], 16, 16); 
            }
            i += 3;
        }
        
        GlStateManager.disableBlend();
        
        FontRenderer fr = mc.fontRenderer;
        String s;
        i = 2;
        for(int x = 20; x < 181; x += 20)
        {
            if(icons[i] != 0)
            {
                s = String.valueOf(icons[i]);
                fr.drawStringWithShadow(s, (float)(screenWidth + x - fr.getStringWidth(s)), y + 9, 16777215);
            }             
            i += 3;
        }
    }
}
