package me.km.networking;

import io.netty.buffer.ByteBuf;
import me.km.KajetansMod;
import me.km.utils.ReflectionUtils;
import net.minecraft.client.Minecraft;
import net.minecraft.util.ResourceLocation;
import net.minecraftforge.fml.common.network.simpleimpl.IMessage;
import net.minecraftforge.fml.common.network.simpleimpl.IMessageHandler;
import net.minecraftforge.fml.common.network.simpleimpl.MessageContext;

public class SeasonUpdate implements IMessage
{
    private byte season;
    
    public SeasonUpdate() 
    {
        season = -1;
    }
    
    public SeasonUpdate(byte season) 
    {
        this.season = season;
    }
    
    @Override
    public void fromBytes(ByteBuf buf) 
    {
        season = buf.readByte();
    }

    @Override
    public void toBytes(ByteBuf buf) 
    {
        buf.writeByte(season);
    }

    public static class Handler implements IMessageHandler<SeasonUpdate, IMessage>
    {
        @Override
        public IMessage onMessage(SeasonUpdate message, MessageContext ctx) 
        {
            switch(message.season)
            {
                case 0:
                    KajetansMod.proxy.setFoliage(new ResourceLocation("textures/colormap/foliage.png"));
                    KajetansMod.proxy.setGrass(new ResourceLocation("textures/colormap/grass.png"));
                    Minecraft.getMinecraft().addScheduledTask(() -> 
                    {
                        Minecraft.getMinecraft().refreshResources();
                    });
                    break;
                case 1:
                    KajetansMod.proxy.setFoliage(new ResourceLocation(KajetansMod.MODID, "textures/colormap/foliage.png"));
                    KajetansMod.proxy.setGrass(new ResourceLocation(KajetansMod.MODID, "textures/colormap/grass.png"));
                    Minecraft.getMinecraft().addScheduledTask(() -> 
                    {
                        Minecraft.getMinecraft().refreshResources();
                    });
                    break;
                case 2:
                    KajetansMod.proxy.setFoliage(new ResourceLocation(KajetansMod.MODID, "textures/colormap/foliage_winter.png"));
                    KajetansMod.proxy.setGrass(new ResourceLocation(KajetansMod.MODID, "textures/colormap/grass_winter.png"));
                    Minecraft.getMinecraft().addScheduledTask(() -> 
                    {
                        Minecraft.getMinecraft().refreshResources();
                    });
                    break;
            }
            return null;
        }
    }
}
